#Eggdrop Toolz 1.1.5 by JBeam2 and FatalDeth
###################
#      MISC       # 
###################

set ver "1.1.5"
putlog "\002\Eggdrop Toolz\002 v.$ver by FatalDeth and JBeam2 #@! \002\LOADED\002 !@#"

set ops "0"
set regular "0"
set voiced "0"
set total "0"

###################
#     BINDS       #        
###################

bind pub o !mode pub:mode
bind pub o !op pub:opme
bind pub o !deop pub:dopme
bind pub o !kick pub:kick
bind pub o !ban pub:ban
bind pub o !unban pub:unban
bind pub - !banlist pub:banlist
bind pub - !stats pub:stats
bind pub f !voice pub:voice
bind pub f !devoice pub:devoice
bind pub m !save pub:save
bind pub - !channels pub:channels
bind pub - !ignores pub:ignorlist
bind pub o !+ignore pub:nignore
bind pub o !-ignore pub:dignore
bind pub m !join pub:join
bind pub m !part pub:part
bind pub n !adduser pub:adduser
bind pub n !rmuser pub:rmuser
bind pub f !say pub:say
bind pub f !act pub:act
bind pub - !help pub:help
bind pub - !ping pub:ping
bind pub m !chattr pub:chattr
bind join - * join:join
bind part - * part:part
bind msg o !auth msg:auth 
bind msg f !say msg:say 
bind msg f !act msg:act
bind pub f !topic pub:topic
bind pub n !rehash pub:rehash
bind ctcr - PING ctcp:reply
bind pub - !mhelp pub:mhelp
bind msg - !help msg:help
bind msg - !mhelp msg:help
bind pub - !reload pub:reload

###################
#    PROCEDURES   #
###################

proc pub:reload {nick uhost hand chan text} {
  if {[matchattr $hand 3]} {
    if {[matchattr $hand n]} {
      putlog "#$nick# !reload"
      putserv "NOTICE $nick :I'm now reloading the bot:"
      reload
      putserv "NOTICE $nick :Bot has been reloaded."
    }
  } else {
    if {[matchattr $hand 3]} {
      putserv "NOTICE $nick :You're not a owner, can't reload bot." 
      putlog "#$nick#(no +n) !reload"
  }
}

proc pub:mhelp {nick uhost hand chan text} {
   global ver
   if {$text == ""} {
     putserv "PRIVMSG $nick :	\002\Welcome to Eggdrop Toolz v.$ver"
     putserv "PRIVMSG $nick :	     by FatalDeth and JBeam2"
     putserv "PRIVMSG $nick :Message Help"
     putserv "PRIVMSG $nick :Type !mhelp !<cmd> for more info on the command"
     putserv "PRIVMSG $nick :------------------------------------------------"
     putserv "PRIVMSG $nick :!auth !act !say"
   }
   if {$text == "!auth"} {
     putserv "PRIVMSG $nick :\002\Usage:\002\ !auth <password>"
     putserv "PRIVMSG $nick :Authenticate yourself so that you can use commands on the bot"
   }
   if {$text == "!act"} {
     putserv "PRIVMSG $nick :\002\Usage:\002\ !act <channel> <action>"
     putserv "PRIVMSG $nick :Make me do an action like typing /me"
   }
   if {$text == "!say"} {
     putserv "PRIVMSG $nick :\002\Usage:\002\ !say <channel> <text>"
     putserv "PRIVMSG $nick :Make me say something in a channel"
   }
   putlog "#$nick# !mhelp"
}

proc msg:mhelp {nick uhost hand text} {
   global ver
   if {$text == ""} {
     putserv "PRIVMSG $nick :	\002\Welcome to Eggdrop Toolz v.$ver"
     putserv "PRIVMSG $nick :	     by FatalDeth and JBeam2"
     putserv "PRIVMSG $nick :Message Help"
     putserv "PRIVMSG $nick :Type !mhelp !<cmd> for more info on the command"
     putserv "PRIVMSG $nick :------------------------------------------------"
     putserv "PRIVMSG $nick :!auth !act !say"
   }
   if {$text == "!auth"} {
     putserv "PRIVMSG $nick :\002\Usage:\002\ !auth <password>"
     putserv "PRIVMSG $nick :Authenticate yourself so that you can use commands on the bot"
   }
   if {$text == "!act"} {
     putserv "PRIVMSG $nick :\002\Usage:\002\ !act <channel> <action>"
     putserv "PRIVMSG $nick :Make me do an action like typing /me"
   }
   if {$text == "!say"} {
     putserv "PRIVMSG $nick :\002\Usage:\002\ !say <channel> <text>"
     putserv "PRIVMSG $nick :Make me say something in a channel"
   }
   putlog "#$nick# !mhelp"
}

proc pub:topic { nick uhost hand chan text } {
  global botnick
  if {[matchattr $hand 3]} {
    if {$text == ""} {
      puthelp "NOTICE $nick :\002\Usage:\002 !topic <topic>"
      return 0
    }
    if {[isop $botnick $chan] == "0"} {
      puthelp "NOTICE $nick :Sorry, I'm not a op on $chan."
      return 0
    }
    if {[isop $botnick $chan] == "1"} {
      putserv "TOPIC $chan :$text"
      putlog "#$nick# !topic $text"
    }
  }
}

proc pub:rehash { nick uhost hand chan text } {
  if {[matchattr $hand n]} {
    putlog "#$nick# !rehash"
    puthelp "NOTICE $nick :Rehashing bot's config file..."
    rehash
  }
}

proc pub:mode {nick uhost hand chan text} {
  global botnick
  if {[matchattr $hand 3]} {
    if {$text == ""} {
      puthelp "NOTICE $nick :\002\Usage:\002\ !mode <mode>"
    }
    if {[isop $botnick $chan] == "0"} {
      puthelp "NOTICE $nick :Sorry, I'm not an op on $chan"
      putlog "#$nick# !mode $chan $text (Failed, not an op)"
    }
    if {[isop $botnick $chan]} {
      putserv "MODE $chan $text"
      putlog "#$nick# !mode $chan $text" 
    }
  }
}

proc pub:opme { nick uhost hand chan text } {
  global botnick
  if {[matchattr $hand 3]} {
    if {$text == ""} {
      if {[isop $botnick $chan] == "0"} {
	puthelp "NOTICE $nick :Sorry, I'm not a op on $chan..."
	return 0
      }  
      if {[isop $botnick $chan] == "1"} {
	if {[isop $nick $chan] == "1"} {
	  puthelp "NOTICE $nick :Sorry, your already a op on $chan."
	  return 0
	}
	if {[isop $nick $chan] == "0"} {
	  putlog "#$nick# !op"
	  putserv "MODE $chan +o $nick"
	  return 0
	 }
      }        
   }
   if {[isop $botnick $chan] == "0"} {
     putlog "#$nick# !op $text $chan (Can't, Not an Op.)"
     puthelp "NOTICE $nick :Sorry, I'm not a op on $chan..."
     return 0
   }
   if {[isop $botnick $chan] == "1"} {
     if {[onchan $text $chan] == "0"} {
       puthelp "NOTICE $nick :Sorry, $text isn't on $chan."
       return 0
     }
     if {[onchan $text $chan] == "1"} {
       if {[isop $text $chan] == "1"} {
	 puthelp "NOTICE $nick :Sorry, $text is already an Op on $chan."
	 return 0
       }
       if {[isop $text $chan] == "0"} {
	 putlog "#$nick# !op $text $chan"
	 putserv "MODE $chan +o $text"
	}
      }
    }  
  }  
}

proc pub:dopme { nick uhost hand chan text } {
  global botnick
  if {[matchattr $hand 3]} {
   if {$text == ""} {
      putserv "MODE $chan -o $nick"
      return 0
   }
   if {[isop $botnick $chan] == "0"} {
     putlog "#$nick# !deop $text $chan (Can't, not an Op.)"
     puthelp "NOTICE $nick :Sorry, I'm not a op on $chan..."
     return 0
   }
   if {[isop $botnick $chan] == "1"} {
     if {[onchan $text $chan] == "0"} {
       puthelp "NOTICE $nick :Sorry, $nick isn't on $chan."
       return 0
     }
     if {[onchan $text $chan] == "1"} {
       if {[isop $text $chan] == "0"} {
	 puthelp "NOTICE $nick :Sorry, $text already is deoped."
	 return 0
       }
       if {[isop $text $chan] == "1"} {
	 putlog "#$nick# !deop $text $chan"
	 putserv "MODE $chan -o $text"
	}
      }
    }
  }
}

proc pub:kick { nick uhost hand chan text } {
  global botnick
  set whom [lindex $text 0]
  set reason [lrange $text 1 end]
  if {[matchattr $hand 3]} {
   if {$whom == ""} {
     puthelp "NOTICE $nick :\002\Usage:\002 !kick <nick> <reason>"
     return 0
   }    
   if {$reason == ""} {
     set reason "Requested"
   }
   if {[isop $botnick $chan] == "0"} {
     putlog "#$nick# !kick $whom $reason (Can't, not an Op.)"
     puthelp "NOTICE $nick :Sorry, I'm not a op on $chan."
     return 0
   }
   if {[isop $botnick $chan] == "1"} {
     if {[onchan $whom $chan] == "0"} {
       puthelp "NOTICE $nick :Sorry, $whom isn't on $chan."
       return 0
     }
     if {[onchan $whom $chan] == "1"} {
       if {$whom == "$botnick"} {
	 putlog "#$nick# !kick $whom $reason *sniff*"
	 puthelp "NOTICE $nick :Excuse me, I wont kick myself."
	 return 0
       }
       if {[isop $whom $chan] == "1"} {
	 puthelp "NOTICE $nick :Sorry, $whom is a op."
	 return 0
       }
       if {[isop $whom $chan] == "0"} {
	 putlog "#$nick# !kick $whom $reason"
	 putserv "KICK $chan $whom :$reason"
	}
      }    
    }  
  }   
}

proc pub:ban { nick uhost hand chan text } {
  global botnick
  set host [lindex $text 0]
  set reason [lindex $text 1]
  set lifetime [lrange $text 2 end]
  if {[matchattr $hand 3]} {
    if {$host == ""} {
      puthelp "NOTICE $nick :\002\Usage:\002 !ban <ban@host> <reason> <ban long>"
      puthelp "NOTICE $nick :Default Reason: 'Requested'  Default Ban Time: 'perm'"
      return 0
    }
    if {$reason == ""} {
      set reason "Requested"
    }  
    if {$lifetime == ""} {
      set lifetime "perm"
    }
    putlog "#$nick# !ban $host $reason $lifetime"
    puthelp "NOTICE $nick :Banning $host, reason: $reason, lifetime: $lifetime"
    newban $host $hand $reason $lifetime
  }
}

proc pub:unban { nick uhost hand chan text } {
  if {[matchattr $hand 3]} {
    if {$text == ""} {
      puthelp "NOTICE $nick :\002\Usage:\002 !unban <ban@host>"
      puthelp "NOTICE $nick :!banlist for a list of bans.
      return 0
    }
    if {[isban $text] == "0"} {
      puthelp "NOTICE $nick :Sorry, Invalid ban. !banlist for a list of bans."
      return 0
    }
    if {[isban $text] == "1"} {
      putlog "#$nick# !unban $text"
      killban $text
    }
  }
}

proc pub:banlist { nick uhost hand chan text } {
  set bans [banlist]
  if {[matchattr $hand 3]} {
    puthelp "PRIVMSG $nick :Listing Current Bans:"
    puthelp "PRIVMSG $nick :$bans"
  if {$bans == ""} {
    puthelp "PRIVMSG $nick :There are no current bans"
    putlog "#$nick# !banlist"
    }
  }
}

proc pub:stats {nick uhost hand chan text} {
  global total regular voiced ops
  if {[matchattr $hand 3]} {
    foreach nick [chanlist $chan] {
      if {[isop $nick $chan] == "0"} {
	incr regular 1
	incr total 1
      } 
      if {[isop $nick $chan] == "1"} {
	incr ops 1
	incr total 1
      }
      if {[isvoice $nick $chan]} {
	incr voiced 1
	incr total 1
      }
    }
    puthelp "PRIVMSG $nick :\002\Total Users\002: $total"
    puthelp "PRIVMSG $nick :\002\Operators\002: $ops"
    puthelp "PRIVMSG $nick :\002\Voiced\002: $voiced"
    puthelp "PRIVMSG $nick :\002\Regulars\002: $regular"
    putlog "#$nick# !stats"
    set total "0"
    set ops "0"
    set voiced "0"
    set regular "0"
  }
}     

proc pub:voice { nick uhost hand chan text } {
  global botnick
  if {[matchattr $hand 3]} {
    if {$text == ""} {
      putserv "MODE $chan +v $nick"
      return 0
    }
    if {[isop $botnick $chan] == "0"} {
      puthelp "NOTICE $nick :Sorry, I'm not a op on $chan."
      return 0
    }
    if {[isop $botnick $chan] == "1"} {
      if {[onchan $text $chan]== "0"} {
	puthelp "NOTICE $nick :Sorry, $text isn't on $chan."
	return 0
      }
      if {[onchan $text $chan]== "1"} {
	if {[isvoice $text $chan] == "1"} {
	  puthelp "NOTICE $nick :Sorry, $text is already voiced."
	  return 0
	}
	if {[isvoice $text $chan] == "0"} {
	  if {[isop $text $chan] == "1"} {
	    putserv "NOTICE $nick :Sorry, I can't voice ops."
	    return 0
	  }
	  if {[isop $text $chan] == "0"} {
	    putlog "#$nick# !voice $text"
	    putserv "MODE $chan +v $text"
	  }
	}  
      }  
    }  
  }
}
 

proc pub:devoice { nick uhost hand chan text } {
  global botnick
  if {[matchattr $hand 3]} {
    if {$text == ""} {
      putserv "MODE $chan -v $nick"
      return 0
    }
    if {[isop $botnick $chan] == "0"} {
      puthelp "NOTICE $nick :Sorry, I'm not a op on $chan."
      return 0
    }
    if {[isop $botnick $chan] == "1"} {
      if {[onchan $text $chan]== "0"} {
	puthelp "NOTICE $nick :Sorry, $text isn't on $chan."
	return 0
      }
      if {[onchan $text $chan]== "1"} {
	if {[isvoice $text $chan] == "0"} {
	  puthelp "NOTICE $nick :Sorry, $text is already devoiced."
	  return 0
	}
	if {[isvoice $text $chan] == "1"} {
	  if {[isop $text $chan] == "1"} {
	    putserv "NOTICE $nick :Sorry, I can't devoice ops."
	    return 0
	  }
	  if {[isvoice $text $chan] == "0"} {
	    putserv "NOTICE $nick :Sorry, I can't devoice someone without voice."
	    return 0
	  }
	  putlog "#$nick# !devoice $text"
	  putserv "MODE $chan -v $text"
	}
      }  
    }  
  }  
}

proc pub:save { nick uhost hand chan text } {
  if {[matchattr $hand 3]} {
    putlog "#$nick# !save"
    puthelp "NOTICE $nick :Saving userfile..."
    save
  }
}

proc pub:channels { nick uhost hand chan text } {
  set clist [channels]
  if {[matchattr $hand 3]} {
    putlog "#$nick# !channels"
    putserv "NOTICE $nick :I'm currently monitoring the following channels,"
    putserv "NOTICE $nick :$clist"
  }
}

proc pub:nignore { nick uhost hand chan text } {
  set host [lindex $text 0]
  set reason [lrange $text 1 end]
  if {[matchattr $hand 3]} {
    if {$host == ""} {
      puthelp "NOTICE $nick :\002\Usage:\002 !ignore <host> <reason>"
      return 0
    }
    if {$reason == ""} { 
      set reason "Requested"
    }
    if {[isignore $text] == "1"} {
      puthelp "NOTICE $nick :Sorry, $text is already being ignored."
      return 0
    }
    if {[isignore $text] == "0"} {
      puthelp "NOTICE $nick :(perm) Now ignoring $host"      
      newignore $host $nick $reason perm
      putlog "#$nick# !+ignore $host $reason perm"
    }
  }
}

proc pub:dignore { nick uhost hand chan text } {
  if {[matchattr $hand 3]} {
    if {$text == ""} {
      puthelp "NOTICE $nick :\002\Usage:\002 !unignore <host>"
      return 0
    }
    if {[isignore $text] == "0"} {
      puthelp "NOTICE $nick :$host is not a valid ignore,"
      puthelp "NOTICE $nick :!ignorelist for a list of ignores."
      return 0
    }
    if {[isignore $text] == "1"} {
      killignore $text
      puthelp "NOTICE $nick :$text is no longer being ignored."
      putlog "#$nick# !-ignore $text"
    }
  }
}

proc pub:ignorlist { nick uhost hand chan text } {
  set lign [ignorelist]
  if {[matchattr $hand 3]} {
    puthelp "PRIVMSG $nick :Listing current ignores,"
    puthelp "PRIVMSG $nick :$lign"
  if {$lign == ""} {
    puthelp "PRIVMSG $nick :There are no ignores."
    putlog "#$nick# !ignores"
    }
  }
}

proc pub:join {nick uhost hand chan text} {
  if {[matchattr $hand 3]} {
    set ch [lindex $text 0]
    if {$ch == ""} {
      puthelp "NOTICE $nick :\002\Usage:\002 !join <chan>"
      return 0
    }
    putlog "#$nick# !join $ch"
    channel add $ch
  }
}

proc pub:part {nick uhost hand chan text} {
  if {[matchattr $hand 3]} {
    set ch [lindex $text 0]
    if {$ch == ""} {
      puthelp "NOTICE $nick :\002\Usage:\002 !part <chan>"
      puthelp "!channels for a list of channels the bot is on."
      return 0
    } 
    putlog "#$nick# !part $ch"
    channel remove $ch
  }
}

proc pub:act {nick uhost hand chan text} {
  if {[matchattr $hand 3]} {
    if {$text == ""} {
      puthelp "NOTICE $nick :\002\Usage:\002 !act <action>"
      return 0
    }
    set action [lrange $text 0 end]
    putserv "PRIVMSG $chan :\001ACTION\ $action"
    putlog "#$nick# !act $text"
  }
}

proc pub:say {nick uhost hand chan text} {
  if {[matchattr $hand 3]} {
    set say [lrange $text 0 end]  
    putmsg $chan "$say"
  }
  if {$text == ""} {
    putserv "NOTICE $nick :\002\Usage:\002\ !say <text>"
    putlog "#$nick# !say $text"
  }
}

proc pub:adduser {nick uhost hand chan text} {
  global botnick
  if {[matchattr $hand 3]} {
    set whom [lindex $text 0]
    set host [getchanhost $whom $chan]
    set host2 [maskhost $host]
    if {$whom == ""} {
      puthelp "NOTICE $nick :\002\Usage:\002 !adduser <nick> <host>"
      return 0
    }
    if {$host == ""} {
      puthelp "NOTICE $nick :\002\Usage:\002 !adduser <nick> <host>"
      puthelp "NOTICE $nick :You need to give $whom a host."
      return 0
    }
    adduser $whom $host2
    putlog "#$nick# !adduser $whom"
    if {[validuser $whom]} {
     putmsg $whom "You have been added to my userfile"
     putmsg $whom "Please set a pass on me"
     putmsg $whom "To do so type /msg $botnick pass passuwant"
     putmsg $whom "Replace passuwant with the password you would like"
    }
  }
}

proc pub:rmuser {nick uhost hand chan text} {
  if {[matchattr $hand n]} {
    set whom [lindex $text 0]
    if {$whom == ""} {
      puthelp "NOTICE $nick :\002\Usage:\002 !rmuser <hand>"
    }
    if {[validuser $whom] == "0"} {
      puthelp "NOTICE $nick :Sorry, not a valid handle."
      return 0
    }
    if {[validuser $whom] == "1"} {
      deluser $whom
      putlog "#$nick# !rmuser $whom"
    }
  }
}

proc pub:ping {nick uhost hand chan text} {
  puthelp "NOTICE $nick :Ping'ing you."
  putserv "PRIVMSG $nick :\001PING [unixtime]\001"
  putlog "!ping received from $nick"
  return 0
}

proc ctcp:reply {nick uhost hand dest key text} {
  if {$key == "PING"} {
    set utime [unixtime]
    set lagtime [expr $utime - $text]
    putserv "NOTICE $nick :You're ping reply is $lagtime seconds"
  }
}

proc pub:chattr {nick uhost hand chan text} {
  set whom [lindex $text 0]
  set flags [lindex $text 1]
  if {[matchattr $hand 3]} {
    if {$whom == ""} {
      puthelp "NOTICE $nick :\002\Usage:\002 !chattr <hand> <attrib>"
      return 0
    }
    if {[validuser $whom] == "0"} {
      puthelp "NOTICE $nick :Sorry, $whom isn't a valid user."
      return 0
    }
    if {[validuser $whom] == "1"} {
      chattr $whom $flags
      putlog "#$nick# !chattr $whom $flags"
    }
  }
}  

proc msg:say {nick uhost hand text} {
  set chan [lindex $text 0]
  set text2 [lrange $text 1 end] 
  if {[matchattr $hand 3]} {
    if {$chan == ""} {
      puthelp "PRIVMSG $nick :\002\Usage:\002 !say <chan> <message>"
      return 0
    }
    if {$text2 == ""} {
      puthelp "PRIVMSG $nick :\002\Usage:\002 !say <chan> <message>"
      return 0
    }
    putmsg $chan "$text2"
    putlog "#$nick# !say $chan text2"
  }
}


proc msg:act {nick uhost hand text} {
  set chan [lindex $text 0]
  set act [lrange $text 1 end]
  if {[matchattr $hand 3]} {
    if {$chan == ""} {
      puthelp "PRIVMSG $nick :\002\Usage:\002 !act <chan> <action>"
      return 0
    } 
    if {$act == ""} {
      puthelp "PRIVMSG $nick :\002\Usage:\002 !act <chan> <action>"
      return 0
    }
    putmsg $chan "\001ACTION\ $act"
    putlog "#$nick# !act $chan $act" 
  }
}

proc msg:auth { nick uhost hand text } {
  set passwd [lindex $text 0]
  if {[matchattr $hand o]} {
    if {$passwd == ""} {
      puthelp "PRIVMSG $nick :\002\Usage: !auth <password>"
      return 0
    }
    if {[matchattr $hand o]} {
      if {[passwdok $hand $passwd]} {
	 putlog "#$nick - $uhost# Authentication Successful."
	 puthelp "PRIVMSG $nick :Authentication Successful."
	 chattr $hand +3
      }
     } else {
      putlog "#$nick - $uhost# Authentication Failed."
      puthelp "PRIVMSG $nick :Authentication Failed."
    } 
  }
}

proc join:join {nick uhost hand chan} {
  chattr $hand -3
}

proc part:part {nick uhost hand chan} {
  chattr $hand -3
}

proc pub:help {nick uhost hand chan text} {
  global ver
  if {$text == ""} {
    putserv "PRIVMSG $nick :       \002\Welcome to Eggdrop Toolz v.$ver"
    putserv "PRIVMSG $nick :            by FatalDeth and JBeam2"
    putserv "PRIVMSG $nick :The following commands are to be used in the channel"
    putserv "PRIVMSG $nick :To get more information on a command type !help !<cmd>"
    putserv "PRIVMSG $nick :---------------------------------------------------"
    putserv "PRIVMSG $nick :\002\Non-Operator Commands:\002"
    putserv "PRIVMSG $nick :!help !mhelp !ping"
    putserv "PRIVMSG $nick :\002\Operator Commands:\002"
    putserv "PRIVMSG $nick :!op !deop !voice !devoice !kick !ban !unban !banlist"
    putserv "PRIVMSG $nick :!mode !stats !act !say !channels !topic !-ignore"
    putserv "PRIVMSG $nick :!+ignore !ignores" 
    putserv "PRIVMSG $nick :\002\Owner Commands:\002"
    putserv "PRIVMSG $nick :!join !part !adduser !rmuser !chattr !save !rehash"
    putserv "PRIVMSG $nick :!reload"
    putserv "PRIVMSG $nick :-----------------------------------------------------"
    putserv "PRIVMSG $nick :The following commands are to be used through message to me"
    putserv "PRIVMSG $nick :To get more information on a command type !mhelp !<cmd>"
    putserv "PRIVMSG $nick :or you can use !help !<cmd>"
    putserv "PRIVMSG $nick :!act !say !auth"
  }
  if {$text == "!op"} {
    putserv "PRIVMSG $nick :\002\Usage:\002\ !op <nick>"
    putserv "PRIVMSG $nick :This will op the nickname of the person whom you specify.  If no nickname is specified, then the bot will op you."
  } 
  if {$text == "!deop"} {
    putserv "PRIVMSG $nick :\002\Usage:\002\ !deop <nick>"
    putserv "PRIVMSG $nick :This will deop the nickname of the person whom you specify.  If no nickname is specified, then the bot will deop you."
  }
  if {$text == "!voice"} {
    putserv "PRIVMSG $nick :\002\Usage:\002\ !voice <nick>"
    putserv "PRIVMSG $nick :This will voice the nickname of the person whom you specify.  If no nickname is specified, then the bot will voice you."
  }
  if {$text == "!devoice"} {
    putserv "PRIVMSG $nick :\002\Usage:\002\ !devoice <nick>"
    putserv "PRIVMSG $nick :This will remove voice from the nickname of the person whom you specify.  If no nickname is specified, then the bot will devoice you."
  }
  if {$text == "!kick"} {
    putserv "PRIVMSG $nick :\002\Usage:\002\ !kick <nick> <reason>"
    putserv "PRIVMSG $nick :This will kick the nickname out of the channel whom you specify."
  }
  if {$text == "!ban"} {
    putserv "PRIVMSG $nick :\002\Usage:\002\ !ban <nick> <host> <lifetime> <reason>"
    putserv "PRIVMSG $nick :This will ban someone"
  }
  if {$text == "!unban"} {
    putserv "PRIVMSG $nick :\002\Usage:\002\ !unban <ban>"
    putserv "PRIVMSG $nick :This will remove a ban from my banlist"
  }
  if {$text == "!banlist"} {
    putserv "PRIVMSG $nick :\002\Usage:\002\ !banlist"
    putserv "PRIVMSG $nick :This will give you a list of the bans in my list"
  }
  if {$text == "!join"} {
    putserv "PRIVMSG $nick :\002\Usage:\002\ !join <channel>"
    putserv "PRIVMSG $nick :This will make me join a channel"
  }
  if {$text == "!part"} {
    putserv "PRIVMSG $nick :\002\Usage:\002\ !part <channel>"
    putserv "PRIVMSG $nick :This will make me leave a channel"
  }
  if {$text == "!mode"} {
    putserv "PRIVMSG $nick :\002\Usage:\002\ !mode <mode>"
    putserv "PRIVMSG $nick :This will change the mode of the channel"
  }
  if {$text == "!adduser"} {
    putserv "PRIVMSG $nick :\002\Usage:\002\ !adduser <nick>"
    putserv "PRIVMSG $nick :Add a user to me"
  } 
  if {$text == "!rmuser"} {
    putserv "PRIVMSG $nick :\002\Usage:\002\ !rmuser <handle>"
    putserv "PRIVMSG $nick :Remove a user from my userfile"
  } 
  if {$text == "!say"} {
    putserv "PRIVMSG $nick :\002\Usage:\002\ !say <text>"
    putserv "PRIVMSG $nick :Make me say something in the channel"
  }
  if {$text == "!act"} {
    putserv "PRIVMSG $nick :\002\Usage:\002\ !act <text>"
    putserv "PRIVMSG $nick :Make me do an action like /me"
  }
  if {$text == "!ping"} {
    putserv "PRIVMSG $nick :\002\Usage:\002\ !ping"
    putserv "PRIVMSG $nick :Make me PING you"
  } 
  if {$text == "!stats"} {
    putserv "PRIVMSG $nick :\002\Usage:\002\ !stats"
    putserv "PRIVMSG $nick :Get the stats on the channel"
  }
  if {$text == "!chattr"} {
    putserv "PRIVMSG $nick :\002\Usage:\002\ !chattr <handle> <flags>"
    putserv "PRIVMSG $nick :Change someone's attributes on the bot"
  }
  if {$text == "!+ignore"} {
    putserv "PRIVMSG $nick :\002\Usage:\002\ !+ignore <host> <reason>"
    putserv "PRIVMSG $nick :Make me ignore someone"
  } 
  if {$text == "!-ignore"} {
    putserv "PRIVMSG $nick :\002\Usage:\002\ !-ignore <ignore>"
    putserv "PRIVMSG $nick :Remove an ignore"
  }
  if {$text == "!ignores"} {
    putserv "PRIVMSG $nick :\002\Usage:\002\ !ignores"
    putserv "PRIVMSG $nick :Get the list of people I am ignoring"
  }
  if {$text == "!save"} {
    putserv "PRIVMSG $nick :\002\Usage:\002\ !save"
    putserv "PRIVMSG $nick :Save my userfile"
  }
  if {$text == "!rehash"} {
    putserv "PRIVMSG $nick :\002\Usage:\002\ !rehash"
    putserv "PRIVMSG $nick :Rehash the bot's config file"
  }
  if {$text == "!channels"} { 
    putserv "PRIVMSG $nick :\002\Usage:\002\ !channels"
    putserv "PRIVMSG $nick :Get a list of the channels I'm on"
  }
  if {$text == "!topic"} {
   putserv "PRIVMSG $nick :\002\Usage:\002\ !topic <topic>"
   putserv "PRIVMSG $nick :Change the topic"
  }
  putlog "#$nick# !help"
}

proc msg:help {nick uhost hand chan text} {
  global ver
  if {$text == ""} {
    putserv "PRIVMSG $nick :	\002\Welcome to Eggdrop Toolz v.$ver"
    putserv "PRIVMSG $nick :	     by FatalDeth and JBeam2"
    putserv "PRIVMSG $nick :The following commands are to be used in the channel"
    putserv "PRIVMSG $nick :To get more information on a command type !help !<cmd>"
    putserv "PRIVMSG $nick :---------------------------------------------------"
    putserv "PRIVMSG $nick :!op !deop !voice !devoice !kick !ban !unban !banlist"
    putserv "PRIVMSG $nick :!join !part !mode !adduser !rmuser !say act !ping"
    putserv "PRIVMSG $nick :!stats !chattr !+ignores !-ignore !ignores !save !rehash"
    putserv "PRIVMSG $nick :!channels !topic"
    putserv "PRIVMSG $nick :-----------------------------------------------------"
    putserv "PRIVMSG $nick :The following commands are to be used through message to me"
    putserv "PRIVMSG $nick :To get more information on a command type !mhelp !<cmd>"
    putserv "PRIVMSG $nick :!act !say !auth"
  }
  if {$text == "!op"} {
    putserv "PRIVMSG $nick :\002\Usage:\002\ !op <nick>"
    putserv "PRIVMSG $nick :This will op the nickname of the person whom you specify.  If no nickname is specified, then the bot will op you."
  } 
  if {$text == "!deop"} {
    putserv "PRIVMSG $nick :\002\Usage:\002\ !deop <nick>"
    putserv "PRIVMSG $nick :This will deop the nickname of the person whom you specify.  If no nickname is specified, then the bot will deop you."
  }
  if {$text == "!voice"} {
    putserv "PRIVMSG $nick :\002\Usage:\002\ !voice <nick>"
    putserv "PRIVMSG $nick :This will voice the nickname of the person whom you specify.  If no nickname is specified, then the bot will voice you."
  }
  if {$text == "!devoice"} {
    putserv "PRIVMSG $nick :\002\Usage:\002\ !devoice <nick>"
    putserv "PRIVMSG $nick :This will remove voice from the nickname of the person whom you specify.  If no nickname is specified, then the bot will devoice you."
  }
  if {$text == "!kick"} {
    putserv "PRIVMSG $nick :\002\Usage:\002\ !kick <nick> <reason>"
    putserv "PRIVMSG $nick :This will kick the nickname out of the channel whom you specify."
  }
  if {$text == "!ban"} {
    putserv "PRIVMSG $nick :\002\Usage:\002\ !ban <nick> <host> <lifetime> <reason>"
    putserv "PRIVMSG $nick :This will ban someone"
  }
  if {$text == "!unban"} {
    putserv "PRIVMSG $nick :\002\Usage:\002\ !unban <ban>"
    putserv "PRIVMSG $nick :This will remove a ban from my banlist"
  }
  if {$text == "!banlist"} {
    putserv "PRIVMSG $nick :\002\Usage:\002\ !banlist"
    putserv "PRIVMSG $nick :This will give you a list of the bans in my list"
  }
  if {$text == "!join"} {
    putserv "PRIVMSG $nick :\002\Usage:\002\ !join <channel>"
    putserv "PRIVMSG $nick :This will make me join a channel"
  }
  if {$text == "!part"} {
    putserv "PRIVMSG $nick :\002\Usage:\002\ !part <channel>"
    putserv "PRIVMSG $nick :This will make me leave a channel"
  }
  if {$text == "!mode"} {
    putserv "PRIVMSG $nick :\002\Usage:\002\ !mode <mode>"
    putserv "PRIVMSG $nick :This will change the mode of the channel"
  }
  if {$text == "!adduser"} {
    putserv "PRIVMSG $nick :\002\Usage:\002\ !adduser <nick>"
    putserv "PRIVMSG $nick :Add a user to me"
  } 
  if {$text == "!rmuser"} {
    putserv "PRIVMSG $nick :\002\Usage:\002\ !rmuser <handle>"
    putserv "PRIVMSG $nick :Remove a user from my userfile"
  } 
  if {$text == "!say"} {
    putserv "PRIVMSG $nick :\002\Usage:\002\ !say <text>"
    putserv "PRIVMSG $nick :Make me say something in the channel"
  }
  if {$text == "!act"} {
    putserv "PRIVMSG $nick :\002\Usage:\002\ !act <text>"
    putserv "PRIVMSG $nick :Make me do an action like /me"
  }
  if {$text == "!ping"} {
    putserv "PRIVMSG $nick :\002\Usage:\002\ !ping"
    putserv "PRIVMSG $nick :Make me PING you"
  } 
  if {$text == "!stats"} {
    putserv "PRIVMSG $nick :\002\Usage:\002\ !stats"
    putserv "PRIVMSG $nick :Get the stats on the channel"
  }
  if {$text == "!chattr"} {
    putserv "PRIVMSG $nick :\002\Usage:\002\ !chattr <handle> <flags>"
    putserv "PRIVMSG $nick :Change someone's attributes on the bot"
  }
  if {$text == "!+ignore"} {
    putserv "PRIVMSG $nick :\002\Usage:\002\ !+ignore <host> <reason>"
    putserv "PRIVMSG $nick :Make me ignore someone"
  } 
  if {$text == "!-ignore"} {
    putserv "PRIVMSG $nick :\002\Usage:\002\ !-ignore <ignore>"
    putserv "PRIVMSG $nick :Remove an ignore"
  }
  if {$text == "!ignores"} {
    putserv "PRIVMSG $nick :\002\Usage:\002\ !ignores"
    putserv "PRIVMSG $nick :Get the list of people I am ignoring"
  }
  if {$text == "!save"} {
    putserv "PRIVMSG $nick :\002\Usage:\002\ !save"
    putserv "PRIVMSG $nick :Save my userfile"
  }
  if {$text == "!rehash"} {
    putserv "PRIVMSG $nick :\002\Usage:\002\ !rehash"
    putserv "PRIVMSG $nick :Rehash the bot's config file"
  }
  if {$text == "!channels"} { 
    putserv "PRIVMSG $nick :\002\Usage:\002\ !channels"
    putserv "PRIVMSG $nick :Get a list of the channels I'm on"
  }
  if {$text == "!topic"} {
   putserv "PRIVMSG $nick :\002\Usage:\002\ !topic <topic>"
   putserv "PRIVMSG $nick :Change the topic"
  }
  putlog "#$nick# !help"
}

